
#include <stdio.h>


enum {
	_clkfreq = 16_000_000,

	SCL = 8,
	SDA = 9,
};


struct __using( "jm_i2c.spin2" ) i2c;



void  main( void )
{
	int  type, addr, devid, count = 0;


	i2c.setup( SCL, SDA, 100, P_HIGH_FLOAT | P_SCHMITT_A );

	getchar();
	printf( "P2 I2C Devices\n-- dddd_aaa_x (8-bit) format\n    00 02 04 06 08 0a 0c 0e\n   -------------------------" );

	for( type = 1; type <= 14; type++ )
	{
		printf( "\n %02x ", type<<4 );
		for( addr = 0; addr <= 7; addr++ )
		{
			devid = (type << 4) | (addr << 1);
			if( i2c.present( devid ) )
			{
				printf( "%02x ", devid );
				count++;
			} else {
				printf( ".. " );
			}
			_waitms( 1 );
		}
	}

	printf( "\nDevices: %d\n", count );
}
